#pragma once

#include <Thread.h>
#include <Critical.h>

#include "DimensionGenerator.h"
#include "Area.h"

class Game;

class WorldGenerator : public Framework::Thread
{
private:
    Framework::Critical cs;
    Framework::Array<Area> requestQueue;
    Game* zGame;
    bool exit;
    int seed;

public:
    WorldGenerator( int seed, Game* zGame );
    ~WorldGenerator();
    void thread() override;
    void requestGeneration( Area request );
    void exitAndWait();
    Framework::Either<Block*, int> generateSingleBlock( Framework::Vec3<int> location, int dimensionId );
};